/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */



/**
 * Classe Level qui gère le décor du jeu.
 * 
 */
Level = function(game) {

	this.oGame = game;

	this.platforms = null;
	this.oGroupStars = null;
};


/**
 * Définition des méthodes de la classe Player
 * 
 * @type {[type]}
 */
Level.prototype = 
{

	/**
	 * Préchargement des éléments de la classe Player
	 * 
	 * @return {[type]} [description]
	 */
	preload: function()
	{
		this.oGame.stage.backgroundColor = '#cccccc';// la couleur de fond du jeu

		this.oGame.load.image('sky', 'assets/sky.png');// les éléments graphiques avec leurs identifiants
	    this.oGame.load.image('ground', 'assets/platform-bois.jpg');
    	this.oGame.load.image('star', 'assets/star-mario.png');
	},


	/**
	 * Création de la scène du jeu,
	 * mise en place des graphismes...
	 * 
	 * @return {[type]} [description]
	 */
	create: function() 
	{
		this.oGame.add.sprite(0, 0, 'sky');// ajoute le background du jeu - image avec identifiant
  
	    this.platforms = this.oGame.add.group();// ajoute les plateformes pour que le héros puisse sauter dessus
	    this.platforms.enableBody = true;// active les lois physique pour les objets ajoutés dans ce groupe
	 
	    var ground = this.platforms.create(0, this.oGame.world.height - 64, 'ground');// création du sol
	    ground.scale.setTo(2, 2);// adapte le sol à la largeur du jeu
	    ground.body.immovable = true;// Stop la chute lorsque le héros tombe sur le sol / impossible de traverser le sol
	 
	    //  création des bords du jeu
	    var ledge = this.platforms.create(400, 400, 'ground');
	    ledge.body.immovable = true;// impossible pour le héros de traverser les bords du jeu
	    ledge = this.platforms.create(-150, 250, 'ground');
	    ledge.body.immovable = true;


	    this.oGroupStars = this.oGame.add.group();// ajout des étoiles dans un groupe
	    this.oGroupStars.enableBody = true;// active les lois physique pour les objets ajoutés dans ce groupe
	 
	    //  création de 12 étoiles
	    for (var i = 0; i < 12; i++)
	    {
	        var star = this.oGroupStars.create(i * 70, 0, 'star');//  création d'une étoile dans le groupe 'étoiles'
	        star.body.gravity.y = 6;// Ajoute la gravité sur l'étoile
	        star.body.bounce.y = 0.7 + Math.random() * 0.3;// valeur de rebond légèrement aléatoire
	    }

	},


	/**
	 * Appelée en continu pendant le jeu
	 * 
	 * @return {[type]} [description]
	 */
	update: function() 
	{
		this.oGame.physics.arcade.collide(this.oGroupStars, this.platforms);// collissions entre les étoiles et les plateformes
	}

};


